"use strict";
const Generator = require("yeoman-generator");
const chalk = require("chalk");
const yosay = require("yosay");

module.exports = class extends Generator {
  async prompting() {
    this.log("欢迎使用" + chalk.blue("众得科技") + "脚手架");
    await this.prompt([
      {
        type: "list",
        name: "projectType",
        message: "请选择项目类型?",
        choices: ["Mobile", "PC"],
        default: "PC"
      }
    ]).then(async answer => {
      if (answer.projectType == "PC") {
        // PC端
        this.answer = Object.assign(
          answer,
          await this.prompt([
            {
              type: "input",
              name: "projectName",
              message: "请输入项目名?",
              default: this.appname // 默认执行yo的所在文件夹名
            },
            {
              type: "input",
              name: "projectDesc",
              message: "请输入项目描述?"
            },
            {
              type: "input",
              name: "projectAuthor",
              message: "请输入项目作者",
              default: "zd.houlei"
            }
          ])
        );
      } else {
        // 移动端
      }
    });
  }

  writing() {
    this.fs.copyTpl(
      this.templatePath("pc"),
      this.destinationPath(this.answer.projectName),
      {
        name: this.answer.projectName,
        description: this.answer.projectDesc,
        author: this.answer.projectAuthor,
        baseUrl: "<%= BASE_URL %>",
        title: "<%= webpackConfig.name %>"
      },
      {},
      {
        globOptions: {
          dot: true
        }
      }
    );
    // This.fs.copyTpl(
    //   this.templatePath("**"),
    //   this.destinationPath(this.answer.projectName),
    //   {
    //     name: this.answer.projectName,
    //     description: this.answer.projectDesc,
    //     author: this.answer.author,
    //     echart: this.answer.echart,
    //     baseUrl: "<%= BASE_URL %>",
    //     title: "<%= webpackConfig.name %>"
    //   },
    //   {
    //     globOptions: {
    //       dot: true
    //     }
    //   }
    // );
    // This.__writingCopy([
    //   ".github",
    //   "build",
    //   "mock",
    //   "plop-templates",
    //   "public",
    //   "src",
    //   "tests",
    //   ".editorconfig",
    //   ".env.development",
    //   ".env.production",
    //   ".env.staging",
    //   ".eslintignore",
    //   ".eslintrc.js",
    //   ".gitignore",
    //   ".travis.yml",
    //   "babel.config.js",
    //   "jest.config.js",
    //   "jsconfig.json",
    //   "LICENSE",
    //   "package.json",
    //   "plopfile.js",
    //   "postcss.config.js",
    //   "vue.config.js"
    // ]);
  }

  __writingCopy(filePath, params) {
    filePath.forEach(item => {
      this.fs.copyTpl(
        this.templatePath(item),
        this.destinationPath(item),
        params
      );
    });
  }

  install() {
    // this.npmInstall([], {     prefix: 'scripts' })
    this.installDependencies({
      bower: false,
      npm: false,
      yarn: false
    });
  }
};
